/******** <lalVerbatim file="FCTMyInterfCV"> ******** 
Author: Wen, L. 
$Id: FCTMyInterf.c,v 1.11 2002/01/09 02:09:30 lwen Exp $ 
********* </lalVerbatim> ********/ 
#include <FCTGeneral.h>

NRCSID( FCTMYINTERFC, "$Id: FCTMyInterf.c,v 1.11 2002/01/09 02:09:30 lwen Exp $");

/* #define NUM_DATA_CUBES 1  */ /* don't know why it is here */

void
LALMyFCTInitPlan(LALStatus *status, FCTInStrucType *fctInStrucs, LALFCTPlan  **fctPlanPtr)
{
  
  

  LALFCTPlan * fctPlan=0;
  /*   INT4 dimension; */
  
  INITSTATUS( status, "FCTMYINTERFC", FCTMYINTERFC ); 
  ATTATCHSTATUSPTR (status);
  
  /* equivalent to fct_init_plan() and  fct_add_phase_function() */

  /* take care of the oversampling factor here for start and end indices *lambda ?  */

  LALCreateFCTPlan(status->statusPtr,&fctPlan,&(fctInStrucs->planIn));  
  
  CHECKSTATUSPTR (status);   

  LALFCTSetUnits(status->statusPtr,&(fctInStrucs->setUnitsIn),fctPlan);
  CHECKSTATUSPTR (status);  


  LALFCTSetMaxSegments(status->statusPtr, fctInStrucs->maxFFTSeg, fctPlan);
  CHECKSTATUSPTR (status);   

  /* add oversampling actor here */
  /*   LALFCTSetOversamplingFactor(status->statusPtr, */

#ifdef FCT_SO_DEBUG

  if(!fctPlan)
  {
    ABORT( status, 1, "null fctPlan1");
  }
#endif

  *fctPlanPtr=fctPlan;

  
  DETATCHSTATUSPTR (status);
  RETURN( status ); 

}


void 
LALMyFCTInterf(LALStatus *status, FCTEventType **event, FCTInParamType *fctInParams)
{

  
  LALFCTPlan                    *fctPlan;
  UINT8                     outputDataSize=0;
  COMPLEX8Vector*            fctOut=0;
  LALFCTSetDataCubesInput   dataCubesIn;
#ifdef FCT_SO_DEBUG
  INT4                        j;
#endif


  INITSTATUS( status, "FCTMYINTERFC", FCTMYINTERFC ); 
  ATTATCHSTATUSPTR (status);

  /*
    fprintf(stdout," in MyFctInterf ()\n");
    fflush( stdout );
  */
   
  fctPlan=fctInParams->fctPlan;


  dataCubesIn.data_cube=fctInParams->cube;
  dataCubesIn.num_data_cubes =fctInParams->numDataCube;

  /* take care of oversampling bussiness, done by changing FCTBaseUnits */
  /*
  for (j=1;j<fctInParams->dimension;j++)
  {
    fctInParams->cube->start_locations[j] *=fctInParams->ofac[j];
    fctInParams->cube->end_locations[j] *=fctInParams->ofac[j];
  }
  */
  /* temp debug */
#ifdef FCT_SO_DEBUG      

  printf("before dataCubeIn\n");
  for (j=0;j<fctInParams->dimension;j++)
  {
    printf("cube: start/end locations are %i,%i\n", fctInParams->cube->start_locations[j],fctInParams->cube->end_locations[j]);
  }
#endif
    
  /*  call FCT search here and return event list */

  LALFCTSetDataCubes(status->statusPtr, &dataCubesIn,fctPlan);
  CHECKSTATUSPTR (status);   
  
  LALFCTOutputDataSize(status->statusPtr,&outputDataSize, fctPlan);
  CHECKSTATUSPTR (status);   
   
#ifdef FCT_SO_DEBUG_DATA

  for (j=0;j<fctInParams->fctInput->length;j++)
  {
    
    printf("fctInput= %g,%g\n",fctInParams->fctInput->data[j].re, fctInParams->fctInput->data[j].im); 
  }

#endif

  /*  Allocate an output vector of this size  */
  LALCCreateVector(status->statusPtr, &fctOut, outputDataSize);
  CHECKSTATUSPTR (status);

  LALFCTCalculate(status->statusPtr, fctOut, fctInParams->fctInput, fctPlan);
  CHECKSTATUSPTR (status);
#ifdef FCT_SO_DEBUG_DATA
  printf("outputDataSize=%u\n", (UINT4) outputDataSize);

  for (j=0;j<outputDataSize;j++)
  {
    printf("fctOut = %g,%g\n",fctOut->data[j].re, fctOut->data[j].im); 
  }
  
#endif
  
  /*  Check fctInParams->fctInput has to be Complex8  */
  LALFCTBuildEvent(status->statusPtr, fctOut, event, fctInParams); /*  creat a linked eventlist */ 
  CHECKSTATUSPTR (status);

  /*  free allocated memories */

  LALCDestroyVector(status->statusPtr, &fctOut);
  CHECKSTATUSPTR (status);

  
  DETATCHSTATUSPTR (status);  
  RETURN( status ); 
}


/* 
void
LALFCTInitEvent(LALStatus *status, FCTEventType **event)
{

  FCTEventType *myEvent;
  myEvent=*event=(FCTEventType *)LALMalloc(sizeof(FCTEventType)) ; //allocate here, deallocate outside
  myEvent->numEvents=0;
  myEvent->fstart=-1;
  myEvent->fend=-1;
  myEvent->tstart=-1;
  myEvent->tend=-1;
  myEvent->whichPlane=-1;
  myEvent->excessPower=0.0;
  myEvent->alpha=0.0;
  myEvent->nextEvent=NULL;
}
*/
/* need to build in calculations for masses and distance */

void
LALFCTBuildEvent(LALStatus *status, COMPLEX8Vector *fctOut, FCTEventType **event,FCTInParamType *fctInParams)
{
  FCTEventType *myEvent;

  INT4   i,j,dimension,dimLength;
  UINT4  length;

  REAL4  totalMass,t0,t2,t3;    
  REAL8  power=0.;
  REAL8  avgP=0.;
  REAL8  sigmaP=0.;
  REAL8  maxP=0., maxProb=1,localMaxP=0,localMaxProb=1;
  REAL8  prob=1,expy; /* false alarm Prob */

  INT4   maxJJ=0,tCnt=0,localMaxJJ=0,tCnt1=0;
  INT4   *maxJ=0,*maxJJJ=0;
  INT4 const numJ=5;
  INT4 const numD=1,tOffset=5; /* check */

  dimension=fctInParams->dimension;
  maxJ=(INT4 *) LALMalloc(sizeof(INT4)*numJ); /*  5 specific to inspiral Check */
  maxJJJ=(INT4 *) LALMalloc(sizeof(INT4)*numD); /* maximum number of slides */
  /*   myEvent=NULL; */

  length=fctOut->length/numD;

  /* initialize the event list */
  /* allocate here, deallocate outside or at the end if #event =0 */

  fctInParams->numEvents=0;

  for (i=0;i<numJ;i++)
  {
    maxJ[i]=0;
  }

  /* use a sliding window */
  /* calculate power (Power=Power/N/sigma2/2), prob, avgP, sigmaP first, power stores in fctOut */
  for (i=0;i<numD;i++)
  {
    localMaxP=0.;
    localMaxProb=1.;
    localMaxJJ=0;

    for (j=i*length;j<(i+1)*length;j++)
    {
    
      power=((fctOut->data[j].re) *(fctOut->data[j].re)/fctInParams->freqMoment->sigma2.re
	     +(fctOut->data[j].im)*(fctOut->data[j].im)/fctInParams->freqMoment->sigma2.im)
             /(fctInParams->dataLength-1.)/2.;
#ifdef FCT_SO_DEBUG_DATA
      printf("power=%f, sigma=%f,%f\n",power,fctInParams->freqMoment->sigma2.re,fctInParams->freqMoment->sigma2.im);
#endif
      expy=exp(-power);
      prob=fctInParams->dataLength * expy;
      if (prob > 0.01) 
      {
	prob=1.-pow((1.-expy),fctInParams->dataLength);
      }

      /* remove zero and Nyq limit bins by offset? */
      if (power >localMaxP  && (j % fctInParams->dataLength) > tOffset 
	  &&  (fctInParams->dataLength - (j % fctInParams->dataLength)) > tOffset )
      {
	  localMaxP=power;
	  localMaxProb=prob;
	  localMaxJJ=j;
      }
            
      avgP +=power;
      sigmaP +=power*power;

    }/* end for j*/


    if (localMaxP>maxP)
    {
      maxP=localMaxP;
      maxProb=localMaxProb;
      maxJJ=localMaxJJ;
    }

    if (localMaxProb<=fctInParams->prob)
    {
      fctOut->data[tCnt].re=localMaxP;
      fctOut->data[tCnt].im=localMaxProb;
      maxJJJ[tCnt]=localMaxJJ;
      tCnt++;
#ifdef FCT_SO_DEBUG
      printf(" maxP, maxProb, maxJJ=%e %e,%i\n",localMaxP,localMaxProb,localMaxJJ);
#endif

    }	
    
  }/*end for i */

  length=length*numD;
  avgP/=length; 
  sigmaP/=(length-1);
  sigmaP -=avgP*avgP/(length-1)*length;
  sigmaP=sqrt(sigmaP);
#ifdef FCT_SO_DEBUG

  for (i=0;i<dimension;i++)
  {
    dimLength=(fctInParams->cube->end_locations[i]-fctInParams->cube->start_locations[i ])/
      fctInParams->cube->stride[i];
    maxJ[i]=fctInParams->cube->start_locations[i ]+(maxJJ % dimLength)*fctInParams->cube->stride[i];
    maxJJ=maxJJ/dimLength;
  }/* end for */

  printf(" in LALFCTBuildEvent()\n");
  printf(" length=%i,avgP=%e, sigP=%e, maxP=%e\n",length,avgP,sigmaP,maxP);
  printf(" max Power occurs at maxJJ=%i,%i,%i,%i,%i\n",maxJ[0],maxJ[1],maxJ[2],maxJ[3],maxJ[4]);
#endif
  for (j=0;j<tCnt;j++)
  {
    power=fctOut->data[j].re;
    prob=fctOut->data[j].im;
    /* prob=1.-pow((1.-exp(-power)),fctInParams->dataLength); */
    /* make sure it is larger than 3 sigma */
    if(prob<=fctInParams->prob && power >=3*sigmaP)
    {
      fctOut->data[tCnt1].re=power;
      fctOut->data[tCnt1].im=prob;
      tCnt1++;
    }
  }
  /* make event list  for
     output top tCnt events  above threshold
  */
  if (tCnt1 !=0)
  {
    myEvent= *event=(FCTEventType *)LALMalloc(sizeof(FCTEventType)) ; 
    
    for (j=0;j<tCnt1;j++)
    {
      power=fctOut->data[j].re;
      prob=fctOut->data[j].im; 
      maxJJ=maxJJJ[j];
      for (i=0;i<dimension;i++)
      {
	maxJ[i]=0;
	dimLength=(fctInParams->cube->end_locations[i]-fctInParams->cube->start_locations[i ])/
	  fctInParams->cube->stride[i];
	maxJ[i]=fctInParams->cube->start_locations[i ]+(maxJJ % dimLength)*fctInParams->cube->stride[i];
	maxJJ=maxJJ/dimLength;
      }/* end for i */
	
	
#ifdef FCT_SO_DEBUG
      printf(" P above threshold at  maxJJ=%i,%i,%i,%i,%i\n",
	     maxJ[0],maxJ[1],maxJ[2],maxJ[3],maxJ[4]);
      printf(" P=%e, prob=%e\n",power,prob);
#endif
      
      myEvent->time.gpsSeconds=fctInParams->epoch.gpsSeconds; 
      myEvent->time.gpsNanoSeconds=fctInParams->epoch.gpsNanoSeconds; 
      
      myEvent->tC=maxJ[0]*2.0*fctInParams->dt; /* 1/Nf, check should input the time series start-time  */
      t0=myEvent->t0=maxJ[1]/FCTBaseUnits[0];  /* 1228.81374; */
      
      /* check, search only t0 and t3, t3 term is at the 2nd phaseFunc */
      t2=myEvent->t2=maxJ[2]/FCTBaseUnits[1]; /* 2405.28188;  */
      t3=myEvent->t3=maxJ[3]/FCTBaseUnits[2]; /* 702.18; */
      
      myEvent->t4=maxJ[4]/FCTBaseUnits[3];
      myEvent->snr=power;
      
      totalMass=fctInParams->totalMassNorm*t3/t0;
      /* etaNorm and totalMassNorm assigned at Initsearch */
      
      myEvent->eta=fctInParams->etaNorm*pow(t0*t0/t3/t3,1./3.)/t3;
      
      /* calculate effective Distance */
      myEvent->effDist=sqrt(myEvent->eta/(power-1.))*pow(totalMass,5./6.)*fctInParams->distNorm;
      
      /* debug */
#ifdef FCT_SO_DEBUG  
      printf("distance is %g \n",myEvent->effDist);
#endif    
	
      
      /* check allowing a 10% error in eta */
      if (myEvent->eta > 0.25 && myEvent->eta <0.275)
      {
	myEvent->eta=0.25;
      }

      /* check for unphysical eta, beaware of the edge point */
      

      
      /* check, masses calculated based on t0 and t3 */
      myEvent->mass1=0.0;
      if (myEvent->eta <=0.25)
      {	  
	myEvent->mass1=(totalMass+totalMass*sqrt(1-4.*myEvent->eta))/2;
      }
      myEvent->mass2=totalMass-myEvent->mass1;

      /* debug */
#ifdef FCT_SO_DEBUG 
      printf("totalMass=%g\n",totalMass);
      printf("mass 1, mass2 =%g,%g\n",myEvent->mass1,myEvent->mass2);
#endif

      myEvent->chisq=prob;
      myEvent->sigma=sigmaP; /*  for inspiral only */
      myEvent->nextEvent=(FCTEventType *)LALMalloc(sizeof(FCTEventType));

      myEvent=myEvent->nextEvent;
      
      myEvent->nextEvent=NULL; 
      
      fctInParams->numEvents++;  	    
    } /* end for j*/
  }/* endif tCnt1!=0 */
  LALFree(maxJ);
  LALFree(maxJJJ);
}

/* calculate average, variance and anything else */
void
LALFCTMoment(LALStatus *status, INT4 length, COMPLEX8 *dataIn, FCTMomentType *moment)
{

 COMPLEX8  avgP;
 COMPLEX8  sigmaP;
 INT4   j;

 INITSTATUS( status, "LALFCTMoment", FCTMYINTERFC ); 
 ATTATCHSTATUSPTR (status);

 avgP.re=0.0;
 avgP.im=0.0;
 sigmaP.re=0.0;
 sigmaP.im=0.0;

/* debug */
#ifdef FCT_SO_DEBUG
 printf("in LALFCTMoment\n ");
 printf("length is %i",length);
#endif  

 for (j=0;j<length;j++)
 {

   avgP.re +=dataIn[j].re;
   sigmaP.re +=dataIn[j].re* dataIn[j].re;
   avgP.im +=dataIn[j].im;
   sigmaP.im +=dataIn[j].im* dataIn[j].im;

 } /* end for */

 if (fabs(sigmaP.re) > 1.0e54 || fabs(sigmaP.re) <1.0e-54) 
 {
   printf("Warning, in FCTMoment, avgP.re,sigmaP=%e,%e\n",avgP.re,sigmaP.re);
 }

 avgP.re/=length; 
 sigmaP.re/=(length-1);


 sigmaP.re -=(avgP.re*avgP.re)/(length-1.)*length;
 avgP.im/=length; 
 sigmaP.im/=(length-1);
 sigmaP.im -=(avgP.im*length*avgP.im)/(length-1.);
 moment->avg=avgP;
 moment->sigma2=sigmaP;


 /* debug */
#ifdef FCT_SO_DEBUG
 printf("avgP.re, sigma.re= %e,%e\n",avgP.re,sigmaP.re);
 printf("out of LALFCTMoment\n ");
#endif

 DETATCHSTATUSPTR (status);
 RETURN( status ); 
}

/* thing shared in Hier code */

/* create and destroy Hier Event list */

FCTHierEventType* 
createHierEvent(INT4 numDims) 
{
  FCTHierEventType *returnEvent; 
  
  returnEvent = LALMalloc(sizeof(FCTHierEventType));
  if (!returnEvent) 
  {
    return(0);
  }

  returnEvent->location = LALMalloc(sizeof(INT4)*numDims);
  if (!returnEvent->location) 
  {
    LALFree(returnEvent); 
    return(0);
  }

  returnEvent->nextEvent = 0;

  return(returnEvent);
}

void 
destroyEventList(FCTHierEventType* event) 
{
  FCTHierEventType *nextEvent; 
  
  while(event) 
  {
    nextEvent = event->nextEvent; 
    LALFree(event->location);
    LALFree(event);
    event = nextEvent; 
  }

}


void SetInitialEvents(LALStatus *status, FCTSearchParams *params) 
{

  REAL4 *minLoc, *maxLoc,*location, tau[4];
  FCTHierEventType head;
  FCTHierEventType *curEvent;
  INT4 *numLoc, dim,kk;
  INT4 const dimension=4; /* check */
  /* relevant to Hier code */
  INT4  numHierLevels=1; /* Hier: assigned in  params->numHierLevels */
  REAL4 *range; /* Hier: passed in? */

  REAL4 etaMin,etaMax,totalMassMin, totalMassMax;
  /*   REAL4 etaAMin; */
  REAL4 tau0Low,tau0High,tau3Low,tau3High,tau2Min,tau2Max,tau4Min,tau4Max;

  UINT4 i,j, k, l, jMin, jMax, lMin, lMax; /* indicies over dimension */



/* specific to inspiral case, only check 4 dimensions */

  INITSTATUS( status, "SetInitialEvents", FCTMYINTERFC );
  /*   ATTATCHSTATUSPTR (status); */

#ifdef FCT_SO_DEBUG
  printf("in SetInitialEvents\n");
#endif   

  /*
  ASSERT( params, status,
	  FCTGENERALH_ENULL, FCTGENERALH_MSGENULL);
  ASSERT( params->fctInParams, status,
	  FCTGENERALH_ENULL, FCTGENERALH_MSGENULL);
  ASSERT( params->hierLevelEvents, status,
	  FCTGENERALH_ENULL, FCTGENERALH_MSGENULL);
  ASSERT( params->hierLevelUnits, status,
	  FCTGENERALH_ENULL, FCTGENERALH_MSGENULL);
  for ( j = 0; j < params->numHierLevels; j++) {
    ASSERT( params->hierLevelUnits[j].range, status,
	    FCTGENERALH_ENULL, FCTGENERALH_MSGENULL);
  }

  */

  /*   dimension=params->fctInParams->dimension-1; */
  /* this subroutine calculate all four dimensions */

#ifdef FCT_SO_DEBUG

  printf("-1 SetInitialEvents\n");


#endif   
  /* Allocate for parameter coordinate vectors. */
  location = (REAL4*)
    LALMalloc(sizeof(REAL4) * (dimension));
  if ( !location ) 
  {
    ABORT( status, FCTGENERALH_EMEM, FCTGENERALH_MSGEMEM );
  }
  
  minLoc = (REAL4*)
    LALMalloc(sizeof(REAL4) * (dimension)); 
  if ( !minLoc ) {
    LALFree( location );
    ABORT( status, FCTGENERALH_EMEM, FCTGENERALH_MSGEMEM );
  }

#ifdef FCT_SO_DEBUG
  printf("0 SetInitialEvents,dim=%i\n",dimension);
#endif   

  maxLoc = (REAL4*)
    LALMalloc(sizeof(REAL4) * (dimension)); 
  if ( !maxLoc ) {
    LALFree( location );
    LALFree( minLoc );
    ABORT( status, FCTGENERALH_EMEM, FCTGENERALH_MSGEMEM );
  }

  numLoc = (INT4*) 
    LALMalloc(sizeof(INT4) * dimension);
  if( !numLoc) 
  {
    LALFree(location);
    LALFree(minLoc);
    LALFree(maxLoc);
    ABORT( status, FCTGENERALH_EMEM, FCTGENERALH_MSGEMEM );
  }

  /* no need for Hier code */
  range = (REAL4*)
    LALMalloc(sizeof(REAL4) * (dimension));
  if ( !range ) {
    LALFree(location);
    LALFree(minLoc);
    LALFree(maxLoc);
    LALFree(numLoc);
    ABORT( status, FCTGENERALH_EMEM, FCTGENERALH_MSGEMEM );
  }

  
#ifdef FCT_SO_DEBUG
  printf("1 SetInitialEvents\n");
#endif  
 
  /* Find corners of hyperrectangle surrounding physical space. */
  ChirpTimes( minLoc, dimension,
	      params->minMass, params->minMass );

#ifdef FCT_SO_DEBUG_DATA
  for ( k = 0; k < dimension; k++ )
  {
    printf("at one corner, tau= %f\n",minLoc[k]);
  }
#endif 

  memcpy( maxLoc, minLoc, sizeof(REAL4) *
	  (dimension) );
  ChirpTimes( location, dimension,
	      params->minMass, params->maxMass );

#ifdef FCT_SO_DEBUG_DATA
  for ( k = 0; k < dimension; k++ )
  {
    printf("at one corner, tau= %f\n",location[k]);
  }
#endif 

  for ( k = 0; k < dimension; k++ ) {
    if ( location[k] < minLoc[k] )
      minLoc[k] = location[k];
    if ( location[k] > maxLoc[k] )
      maxLoc[k] = location[k];
  }
  ChirpTimes( location, dimension,
	      params->maxMass, params->maxMass );

#ifdef FCT_SO_DEBUG_DATA
  for ( k = 0; k < dimension; k++ )
  {
    printf("at one corner, tau= %f\n",location[k]);
  }
#endif 

  for ( k = 0; k < dimension; k++ ) {
    if ( location[k] < minLoc[k] )
      minLoc[k] = location[k];
    if ( location[k] > maxLoc[k] )
      maxLoc[k] = location[k];
  }


  /* check, need to input the min, max for Tau0 and Tau3 */
  dim=params->dimension-1;
  for (i=0; i < dim; i++)  
  {
    /* oversampling issue is taken care of in FCTBaseUnits */ 
    numLoc[i]=ceil(maxLoc[i]*FCTBaseUnits[i])-floor(minLoc[i]*FCTBaseUnits[i])+1; 
    numLoc[i]=ceil(1.0*numLoc[i]/params->segLengthPerRun[i+1]);
    range[i]=params->segLengthPerRun[i+1]/FCTBaseUnits[i];
    /*
    numLoc[i]=ceil(maxLoc[i]/range[i])-floor(minLoc[i]/range[i])+1; 
    */
    /* to make sure that the last point will be included */

  }

  /* assuming other segLengthPerRun=1 at other dim if not input */
  for (i=dim; i<dimension; i++)
  {
    range[i]=1.0/FCTBaseUnits[i];
    numLoc[i]=ceil(maxLoc[i]*FCTBaseUnits[i])-floor(minLoc[i]*FCTBaseUnits[i])+1;
  }

#ifdef FCT_SO_DEBUG
  for ( k = 0; k < dimension; k++ ) 
  {
    printf("dim-dimen,dim,unit, min, max, numLoc, range= %i,%i,%f, %f, %f, %i,  %f\n",dim-dimension,k,FCTBaseUnits[k], minLoc[k],maxLoc[k],numLoc[k],range[k]);
  }
#endif
   
  /* Free up some memory, and allocate an array of indicies. */
  LALFree( maxLoc );
  LALFree(location);
  
  
  /* use location to store array tau[] */

  /* Initialize event lists. */
  memset( params->hierLevelEvents, 0, numHierLevels*sizeof(FCTHierEventType *) );
#ifdef FCT_SO_DEBUG
  printf("2 SetInitialEvents\n");
#endif  


  head.nextEvent = NULL;
  curEvent = &head;
  
#ifdef FCT_SO_DEBUG
  printf("3  SetInitialEvents\n");
#endif  

  /*   move from minLoc to maxLoc in steps of params->hierLevelUnits[0].range[k]: */
  for (i=0; i < numLoc[0]; i++)
  {

   tau[0]=minLoc[0]+i*range[0];
   tau0Low=tau[0];
   tau0High=minLoc[0]+(i+1)*range[0]-1.0/FCTBaseUnits[0]; 

   for (k=0; k < numLoc[2]; k++)
   {
     tau[2]=minLoc[2]+k*range[2]; 
     tau3Low=tau[2];
     tau3High=minLoc[2]+(k+1)*range[2]-1.0/FCTBaseUnits[2];
     
#ifdef FCT_SO_DEBUG_DATA
     printf("i,k,tau0, tau3=%i,%i, %f,%f\n",i,k,tau[0],tau[2]); 
#endif

     /* it is physical point if minEta < 0.25 in the grid to enhance the chance of detection  */
     if (etaFunc(tau0Low,tau3High) <= 0.25 )  
     {
       
#ifdef FCT_SO_DEBUG_DATA
       printf("i,k,tau0, tau3=%i,%i, %f,%f\n",i,k,tau[0],tau[2]); 
#endif
       /* treat m1=m2 BC, increase t3 until it hit the BC */
       /*
       if (etaFunc(tau[0],tau[2]) > 0.25 )  
       {
	 tau[2]=pow(5.12*LAL_PI*LAL_PI*tau[0]*tau[0]/f0/f0/f0,0.2);
	 tau3Low=tau[2];
#ifdef FCT_SO_DEBUG
	 printf(" BC, eta,tau3 =%f,%f\n",etaFunc(tau[0],tau[2]),tau[2]);
#endif
       }
       */
       etaMin=minFunc(etaFunc(tau0Low,tau3High),0.25);
       etaMax=minFunc(etaFunc(tau0High,tau3Low),0.25);
       
       totalMassMin=minFunc(maxFunc(totalMassFunc(tau3Low,tau0High),2*params->minMass),2*params->maxMass);
       totalMassMax=minFunc(maxFunc(totalMassFunc(tau3High,tau0Low),2*params->minMass),2*params->maxMass);
       
#ifdef FCT_SO_DEBUG_DATA
       /*        printf("eta, totalMass,min,max=%f,%f,%f,%f\n",etaMin,etaMax,totalMassMin,totalMassMax); */
#endif
      
       tau2Min=tau2MEFunc(totalMassMax,etaMax);
       tau2Max=tau2MEFunc(totalMassMin,etaMin);
       
       
       /*        if(etaMax < etaAMin)  which is true in this case */
       
       {
	 tau4Min=tau4MEFunc(totalMassMax,etaMax);
	 tau4Max=tau4MEFunc(totalMassMin,etaMin);
       }

       jMin=floor((tau2Min-minLoc[1])/range[1]);       
       jMax=ceil((tau2Max-minLoc[1])/range[1])+1;
       lMin=floor((tau4Min-minLoc[3])/range[3]);
       lMax=ceil((tau4Max-minLoc[3])/range[3])+1;
       
#ifdef FCT_SO_DEBUG_DATA
       /*        printf(" before jmin,jmax,lmin,lmax=%i, %i,%i,%i\n",jMin,jMax,lMin,lMax); */
#endif
       
       /* make sure it is between 0 and numLoc */
       if (jMin < 0)
       {
	 jMin=0;
       }
       else if (jMin>numLoc[1])
       {
	 jMin=numLoc[1];
       }

       if (jMax < 0)
       {
	 jMax=0;
       }
       else if (jMax>numLoc[1])
       {
	 jMax=numLoc[1];
       }
	 
       if (lMin < 0)
       {
	 lMin=0;
       }
       else if (lMin>numLoc[3])
       {
	 lMin=numLoc[3];
       }

       if (lMax < 0)
       {
	 lMax=0;
       }
       else if (lMax>numLoc[3])
       {
	 lMax=numLoc[3];
       }

#ifdef FCT_SO_DEBUG
       
       /*        printf("after jmin,jmax,lmin,lmax=%i, %i,%i,%i\n",jMin,jMax,lMin,lMax); */
#endif
       
       for (j=jMin; j<jMax; j++)
       {
	 tau[1]=minLoc[1]+j*range[1]; /* tau2 */
	 
	 for (l=lMin; l<lMax; l++)
	 {
	   tau[3]=minLoc[3]+l*range[3];/* tau4 */
	   

	   curEvent->nextEvent =
	     createHierEvent(dimension );
	   curEvent = curEvent->nextEvent;
	   
	   if (!curEvent) 
	   {
	     destroyEventList( head.nextEvent );
	     LALFree(minLoc);
	     LALFree(numLoc); 
	     ABORT( status, FCTGENERALH_EMEM, FCTGENERALH_MSGEMEM );
	   }

	   for (kk=0; kk<dimension; kk++)
	   {
	     curEvent->location[kk] = tau[kk];
	   }
	   params->totalNumSeg++;

#ifdef FCT_SO_DEBUG
	   /* 
	   printf("i,k,j,l, Seg=%i,%i,%i,%i,%i\n",i,k,j,l,params->totalNumSeg);

	   
	   for ( kk = 0; kk < dimension; kk++ )
	   {
	     printf("tau[%i]= %f \t",kk,tau[kk]);
	   }
	   
	   printf(" \n");
	   */
#endif


	   /* 	   mySearchParams->numHierLevelEvents[0]++; */ /* for Hier code */

	 } /* endfor l, tau4 */
       }/* endfor j, tau2 */ 
     }/* endif minEta <0.25 */
   } /* endfor j, tau3 */
 }/* endfor i, tau0 */


 params->hierLevelEvents[0] = head.nextEvent;

 /* free memories */
 LALFree( minLoc );
 LALFree(numLoc);
 LALFree(range);
#ifdef FCT_SO_DEBUG
  printf("leaving SetInitialEvents\n");
#endif  

  /*  DETATCHSTATUSPTR (status);  */
 RETURN( status ); 

}/* end main */
     
REAL4 tau2MEFunc(REAL4 m, REAL4 eta) 
{
  return (3715+4620*eta)/(64512*eta*m*pow(LAL_PI*f0,2.))/LAL_MTSUN_SI;
}
  
REAL4 tau4MEFunc(REAL4 m, REAL4 eta)
{
  return 5./(128.*eta*pow(m,1./3.)*pow(LAL_PI*f0,4./3.))*(3058673./1016064.+5429./1008*eta+617./144*eta*eta)/pow(LAL_MTSUN_SI,1./3.);
}
  
REAL4 totalMassFunc(REAL4 tau3, REAL4 tau0)
{
  return 5./32./LAL_PI/LAL_PI/f0/LAL_MTSUN_SI*tau3/tau0;
}

REAL4 etaFunc(REAL4 tau0, REAL4 tau3)
{
  /* return pow(2*LAL_PI/f0*LAL_PI/25./f0/f0*tau0/tau3/tau3*tau0/tau3/tau3/tau3,1./3.); */
  return pow(2*LAL_PI*LAL_PI/25.*tau0*tau0/tau3/tau3,1./3.)/tau3/f0;

}



void ChirpTimes( REAL4 *tau, UINT4 dim, REAL4 m1, REAL4 m2 )
{
  UINT4 i;  /* index over tau data, and its maximum value */
  REAL4 mSec = m1 + m2;                /* total system mass */
  REAL4 eta = ( m1/mSec )*( m2/mSec ); /* reduced mass ratio */
  /*   mSec /= LAL_MTSUN_SI;  */              /* total mass in units of s */



  /* Compute tau0, tau2, tau3, tau4. */
  if ( dim > 0 ) 
  {
    tau[0]=5./256/pow(mSec, 5./3.)/pow(LAL_MTSUN_SI,5./3.)/pow(LAL_PI*f0,8./3)/eta;
  }
  if ( dim > 1 )
  { 
    /*     tau[1] = ( (5.0/192.0)*mSec/eta )      * ( (11.0/4.0)*eta + (743.0/336.0) )      * pow( LAL_PI*mSec*f0, -2.0 ); */
   tau[1]=(3715+4620*eta)/(64512*eta*mSec*pow(LAL_PI*f0,2.))/LAL_MTSUN_SI; 
  }
  if ( dim > 2 )
  {
    tau[2]=LAL_PI/(8*eta*pow(mSec,2./3.)*pow(LAL_PI*f0,5./3.))/pow(LAL_MTSUN_SI,2./3.);
  }  

  if ( dim > 3 )
  {
    tau[3] =5./(128.*eta*pow(mSec,1./3.)*pow(LAL_PI*f0,4./3.))*(3058673./1016064.+5429./1008*eta+617./144*eta*eta)/pow(LAL_MTSUN_SI,1./3.);
  }
#ifdef FCT_SO_DEBUG_DATA
    printf("in Chirptimes, dim,m1,m2=%i,%f, %f\n",dim, m1,m2);
    for ( i = 0; i < dim; i++ )
    {
      printf("tau1,2, eta=%f, %f, %f\n",tau[i],( (5.0/256.0)*mSec/eta )
      * pow( LAL_PI*mSec*f0, -(8.0/3.0) ), eta);
    }
#endif


  /* Set any remaining fields to zero. */
  for ( i = 4; i < dim; i++ )
    tau[i] = 0.0;



  return;


}

REAL4 minFunc(REAL4 x, REAL4 y)
{
  return (x<=y ? x:y);
}
REAL4 maxFunc(REAL4 x, REAL4 y)
{
  return (x>=y ? x:y);
}
