#!/bin/sh
srcdir=${srcdir:-.}
ilwd=`cd $srcdir && pwd`/Test.ilwd
dso=`pwd`/.libs/libldastest.so
WRAPPER_RESOURCE_FILE=`cd $srcdir && pwd`
have_wrapperAPI=0
save_IFS="$IFS"
IFS=:
for d in $PATH; do
  if test -x $d/wrapperAPI ; then
    have_wrapperAPI=1
    break
  fi
done
IFS="$save_IFS"
if test $have_wrapperAPI -eq 0 ; then
  echo "Program wrapperAPI not in path; ignore test"
  exit 77
fi
if test ! -f $ilwd ; then
  echo "Error: file $ilwd does not exist"
  exit 1
fi
if test ! -f $dso ; then
  echo "Error: library $dso does not exist"
  exit 1
fi
if test ! -d NORMAL_0 ; then
  mkdir NORMAL_0
fi
if test ! -d NORMAL_0/NORMAL8 ; then
  mkdir NORMAL_0/NORMAL8
fi
cat > Test.schema <<EOF
h -np 3 wrapperAPI -mpiAPI="(marfik.ligo.caltech.edu,10000)" -nodelist="(1-2)" -dynlib="$dso" -dataAPI="(datahost,5678)" -resultAPI"=(reshost, 9101)" -filterparams="(arg1,arg2)" -realTimeRatio=0.9 -doLoadBalance=FALSE -dataDistributor=W -jobID=8 -inputFile="$ilwd"
EOF
lamboot -v
rm -f $$.status
mpirun -v Test.schema || echo "$?" > $$.status
wipe -v
if test -f $$.status
then
  code=`cat $$.status`
  rm -f $$.status
  exit $code
fi
